#! /usr/bin/env python
# coding: koi8-r
"""Search tags CGI"""

__author__ = "Oleg Broytman <phd@phdru.name>"
__copyright__ = "Copyright (C) 2014-2017 PhiloSoft Design"
__license__ = "GNU GPL"

import cgi, sys
from parsimonious import ParseError
from html.response import redirect, response
from parser import parser

form = cgi.FieldStorage()
if not form.has_key('q'):
    status = "400 Bad request"
    title = "Error!"
    body = "Required parameter is missing!"

else:
    q = form['q'].value
    try:
        tree = parser.compile(q)
    except ParseError:
        status = "400 Bad request"
        title = "Error!"
        body = "Bad query syntax!"
    else:
        if tree[0] == 'NAME': # Single tag - just do redirect
            tag = tree[1]
            assert isinstance(tag, str)
            from tags import tag_exists
            if tag_exists(tag):
                redirect("/Russian/blog/tags/%s.html" % tag, status="301 Moved")
                sys.exit()
            status = "404 Tag not found"
            title = "!"
            body = " %s  !" % tag
        else: # Process tree
            from tags import find_tags
            posts = find_tags(tree)
            status = None
            title = ",    " + cgi.escape(q)
            if posts:
                _posts = ["""\
    <p class="head">
    <ul>
    """]
                for year, month, day, suburl, _title in posts:
                    _posts.append('<li>%s-%s-%s <a href="../../../../Russian/blog/%s">%s</a></li>\n' % (year, month, day, suburl, _title))
                _posts .append("""\
    </ul>
    </p>
    """)
                body = ''.join(_posts)
            else:
                body = "    ."

response(title, body, status)
